/*
 * Copyright (c) 2012, IDM
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright notice, this list of
 *       conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright notice, this list
 *       of conditions and the following disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 *     * Neither the name of the IDM nor the names of its contributors may be used to endorse or
 *       promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

require('skpublishapi.js');

var ReadLine = require('ReadLine');
var stdin = new ReadLine('apiTest.js', 0);

stdin.prompt('Enter your site domain name (i.e. myapisite.com):');
var serverName = stdin.gets();

stdin.prompt('Enter your access key:');
var accessKey = stdin.gets();

var api = new SkPublishAPI ('https://'+serverName+'/api/v1', accessKey);

var cURL = require('cURL');
api.setRequestHandler({
  executeRequest : function(config) {
    var result = cURL(config);
    return result.responseText;
  },

  prepareGetRequest : function(uri, accessKey) {
    var headers = {
      'Host': serverName,
      'accessKey': accessKey,
      'Content-Type': 'application/json'
    };

    var options = {
      url: uri,
      method: 'GET',
      headers: headers
    };

    return options;
  }
});

print ("*** Dictionaries\n");
dictionaries = api.getDictionaries();
print (dictionaries+"\n");

dict = eval(dictionaries)[0];
for(var elt in dict){
  infoVal = eval("dict."+elt);
  if (typeof infoVal == 'function') { continue; }
  print (elt + " : " + infoVal + " ; ");
}
print ("\n");
dictCode = dict.dictionaryCode;

print ("*** Search\n");
print ("*** Result list\n");
results = api.search(dictCode, "ca", 1, 1);
print (results+"\n");
print ("*** Spell checking\n");
spellResults = api.didYouMean(dictCode, "dorg", 3);
print (spellResults+"\n");
print ("*** Best matching\n");
bestMatch = api.searchFirst(dictCode, "ca", "html");
print (bestMatch+"\n");

print ("*** Nearby Entries\n");
nearbyEntries = api.getNearbyEntries(dictCode, eval('['+bestMatch+']')[0].entryId, 3);
print (nearbyEntries+"\n");
